//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_cli_open_module_eth.c
//	project: delib-cli
//
//
//  (c) DEDITEC GmbH, 2014
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	12.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// read_config_file_and_get_params
// delib_cli_open_module

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include <string.h>

#include "delib_cli_defines.h"

#include "../../delib-sources/delib/library/delib/delib.h"
#include "../../delib-sources/delib/library/embedded/dt_var_defines.h"
#include "../../delib-sources/delib/library/vc/deditec_string_utils.h"

// ------------------------------------
// ------------------------------------
// Global Vars
// ------------------------------------
// ------------------------------------

char global_ip_addr[20];

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG read_config_file_and_get_params(unsigned long *buffer_module_id, unsigned long *buffer_module_nr)
{
    FILE *cfg_file;
    char text_buffer[100];
	char *text_content = NULL;
	char *param = NULL;
	bool found_RoETH = FALSE;
    
	cfg_file = fopen(CLI_CFG_FILE, "r");		// open cfg-file
	
    if(!cfg_file) 	// can not open cfg-file
	{
        printf("ERROR: Can not open 'delib_cli.cfg'\n");
    }
	else
	{
		while(!feof(cfg_file)) 		// end of file
		{
			if(fscanf(cfg_file, "%s", text_buffer) == EOF) 	
			{
				break;
			} 
			else 
			{
				param = (char*) strtok(text_buffer, "=");				// a=b;	-> a
				text_content = (char*) strtok( NULL, "=");				// a=b; -> b;
				text_content = (char*) strtok(text_content, ";");		// a=b; -> b
				
				if (strcmp(param, RO_ETH_IP) == 0)
				{
					sprintf(global_ip_addr, "%s", text_content);
					found_RoETH = TRUE;
				}
			}
		}		
	}
	
	fclose(cfg_file);
	
	if (found_RoETH == FALSE)
	{
		printf("ERROR: No entry for IP address found in 'deditec.cfg'\n");
		return RETURN_ERROR;
	}
	else
	{
		return RETURN_OK;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG delib_cli_open_module(unsigned long moduleID, unsigned long moduleNR)
{
	DAPI_OPENMODULEEX_STRUCT open_buffer;
	ULONG handle;

	strcpy_n((char*) open_buffer.address, sizeof(open_buffer.address), global_ip_addr, strlen_n(global_ip_addr, sizeof(global_ip_addr)));
	open_buffer.timeout = 1000;				// 1000 msec
	open_buffer.portno = 9912;				// using default port

	handle = DapiOpenModuleEx(ETHERNET_MODULE, 0, (unsigned char*) &open_buffer, DAPI_OPEN_MODULE_OPTION_USE_EXBUFFER);
	
	return handle;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
