//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_cli_open_module_usb.c
//	project: delib-cli
//
//
//  (c) DEDITEC GmbH, 2014
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	12.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// read_config_file_and_get_params
// delib_cli_open_module

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "delib_cli_defines.h"
#include "../../delib-sources/delib/library/delib/delib.h"
#include "../../delib-sources/delib/library/embedded/dt_var_defines.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG read_config_file_and_get_params(unsigned long *buffer_module_id, unsigned long *buffer_module_nr)
{
    FILE *cfg_file;
    char text_buffer[100];
	bool found_ModuleID = FALSE;
	bool found_ModuleNr = FALSE;
	bool found_ValidModuleID = FALSE;
	
	char *ptr;
	char param[20];
	char value[20];
	unsigned long len;
	
    cfg_file = fopen(CLI_CFG_FILE, "r");		// open cfg-file
    if(cfg_file == NULL) 	// can not open cfg-file
	{
        printf("ERROR: Can not open 'delib_cli.cfg'\n");
    }
	else
	{
		while(!feof(cfg_file)) 		// end of file
		{
			if(fscanf(cfg_file, "%s", text_buffer) == EOF) 	
			{
				break;
			} 
			else 
			{	
				if (ptr = strchr(text_buffer, '='))
				{
					len = ptr-text_buffer;
					
					strncpy(param, text_buffer, len);
					param[len] = 0;
					
					len=strlen(ptr+1)-1;
					strncpy(value, ptr+1, len);
					value[len] = 0;
				}
				
				if (strcmp(param, MODULE_ID) == 0)
				{
					*buffer_module_id = (unsigned long) atoi(value);
					found_ModuleID = TRUE;
				}
				else if (strcmp(param, MODULE_NR) == 0)
				{
					*buffer_module_nr = (unsigned long) atoi(value);
					found_ModuleNr = TRUE;
				}
			}
		}
	}
	
    fclose(cfg_file);
	
	if ((found_ModuleID == FALSE) || (found_ModuleNr == FALSE))
	{
		printf("ERROR: No entry for moduleID and/or moduleNR found in 'delib_cli.cfg'\n");
		return RETURN_ERROR;
	}
	else
	{
		switch(*buffer_module_id)
		{
			case RO_USB1:
			case USB_MINI_STICK:
			case USB_OPTOIN_8:
			case USB_OPTOIN_8_RELAIS_8:
			case USB_OPTOIN_16_RELAIS_16:
			case USB_OPTOIN_32_RELAIS_32:
			case USB_TTL_32:
			case RO_USB2:
			case NET_USB2:
			case NET_USB1:
				found_ValidModuleID = TRUE;
				break;
				
			default:
				printf("ERROR: Value of moduleID in 'delib_cli.cfg' is not valid\n");
					printf("List of supported moduleIDs\n");
					printf("RO-USB=7\n");
					printf("USB-MINI-Stick=9\n");
					printf("USB-OPTOIN-8=14\n");
					printf("USB-RELAIS-8=14\n");
					printf("BS-USB-OPTOIN-8_RELAIS_8=15\n");
					printf("BS-USB-OPTOIN-16_RELAIS_16=16\n");
					printf("BS-USB-OPTOIN-32=16\n");
					printf("BS-USB-RELAIS-32=16\n");
					printf("BS-USB-OPTOIN-32_RELAIS_32=17\n");
					printf("BS-USB-OPTOIN-64=17\n");
					printf("BS-USB-RELAIS-64=17\n");
					printf("USB-TTL-32=18\n");
					printf("USB-TTL-64=18\n");
					printf("RO-USB2=25\n");
					printf("NET_USB2=31\n");
					printf("NET_USB1=33\n");

				break;
		}
		
		if (found_ValidModuleID == FALSE)
		{
			return RETURN_ERROR;
		}
		else
		{
			return RETURN_OK;
		}
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG delib_cli_open_module(unsigned long moduleID, unsigned long moduleNR)
{
	unsigned long handle = 0;
	handle = DapiOpenModule(moduleID, moduleNR);
	return handle;
}