//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_utilities1.cpp
//	project: delib
//
//
//  (c) DEDITEC GmbH, 2013
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// Fr alle deditec_tcp_io functions:
// IsError
// delib_get_device_nr_of_first_module
// check_delib_version_groesser_gleich
// delib_open_first_module
// show_fw_version
// check_fw_version_groesser_gleich


// wird nicht mehr gebraucht !
// ro_special_cmd_read
// ro_special_cmd_write
// ro_special_cmd_set_module

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <windows.h>
#include <stdio.h>
#include "conio.h"


#include "../delib/delib.h"
#include "../delib/delib_extended_functions.h"
#include "../embedded/dt_var_defines.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

BOOL IsError()
{
	unsigned char msg[500];
	unsigned long err;
	
	err = DapiGetLastError();
	if (err != DAPI_ERR_NONE)
	{
		DapiGetLastErrorText((unsigned char*) msg, sizeof(msg));

		printf("*******************************************************************************\n");
		printf("DAPI-ERROR Code = %d (dez)\n", (long) err);
		printf("MSG=%s\n", msg);
		printf("*******************************************************************************\n");
		
		DapiClearLastError();

		return TRUE;
	}
	return FALSE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void GetModuleName(ULONG moduleID, char* ModName, unsigned long ModNameSize)
{
	DapiInternCommand(DAPI_INTERN_GET_MODULE_NAME, 0, 0, ModName, ModNameSize, &moduleID);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DelibSetProgName(unsigned long handle, char* text)	
{
	if (handle != 0) 
	{
	  DapiSpecialCommand(handle, DAPI_SPECIAL_CMD_DELIB_SET_PROG_NAME, 0, 0, (unsigned long) text);
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void check_module_params(unsigned long handle)
{
	ULONG sw_feature1;
	ULONG hw_interface1;
	
	sw_feature1 = DapiSpecialCommand(handle, DAPI_SPECIAL_CMD_GET_MODULE_CONFIG, DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_SW_FEATURE1, 0, 0);
	IsError();
	hw_interface1 = DapiSpecialCommand(handle, DAPI_SPECIAL_CMD_GET_MODULE_CONFIG, DAPI_SPECIAL_GET_MODULE_CONFIG_PAR_HW_INTERFACE1, 0, 0);
	IsError();
	
	if ( ((sw_feature1 & DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE) == 0) || \
		 ((hw_interface1 & DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE) == 0) )
	{
		printf("*******************************************************************************\n");
		printf("*******************************************************************************\n");
		printf("ACHTUNG: Firmware ist veraltet !!!!!! Bitte Firmware aktualisieren !!!!!!!\n");
		printf("*******************************************************************************\n");
		printf("*******************************************************************************\n");
		
		printf("Taste fr weiter!\n");
		getch();
	}
		 
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG delib_get_device_nr_of_first_module(unsigned long *ret_moduleNr, unsigned long *ret_moduleID, unsigned long sub_device)
{
	ULONG device_nr=1;
	ULONG handle=0;
	ULONG NrOfModules;
	ULONG modulePos;

	ULONG moduleID;
	ULONG moduleNr;
	
	ULONG moduleID_first;
	ULONG moduleNr_first;
	
	ULONG Eingabe_module_nr;
	
	char ModName[30];


	NrOfModules = DapiScanAllModulesAvailable(0);

	printf("*************************************************************|\n");
	printf("Scanne Module........                                        |\n");
	printf("*************************************************************|\n");
	printf("Anzahl Module: %2d                                            |\n", NrOfModules);
	printf("-------------------------------------------------------------|\n");

	modulePos = 1;
	while(modulePos <= NrOfModules)
	{
		moduleNr = DapiScanAllModulesAvailable(modulePos);		// Werte holen ... ab Nr 1
		moduleID = (moduleNr >> 16) & 0xff;
		moduleNr &= 0xffff;
		
		GetModuleName(moduleNr, ModName, sizeof(ModName));

		if(modulePos==1)
		{
			moduleID_first = moduleID;
			moduleNr_first = moduleNr;
		}

		printf("Modul %d = 0x%2x - Module-ID = 0x%2x       %-20s |\n", modulePos, moduleNr, moduleID,  ModName);
		++modulePos;
	}

	printf("*************************************************************|\n");

	if(NrOfModules > 1)
	{
		printf("Welches Modul moechten Sie oeffnen ?\n");
		printf("Eingabe: (1..%d): ", NrOfModules);
		do
		{
			scanf("%d", &Eingabe_module_nr);
		} while((Eingabe_module_nr < 1) || (Eingabe_module_nr > NrOfModules));
	}

	moduleNr = DapiScanAllModulesAvailable(Eingabe_module_nr);		// Werte holen ... ab Nr 1
	moduleID = (moduleNr >> 16) & 0xff;
	moduleNr &= 0xffff;

	GetModuleName(moduleNr, ModName, sizeof(ModName));
	
	*ret_moduleNr = moduleNr;
	*ret_moduleID = moduleID;
	
	printf("*************************************************************|\n");
	printf("Ausgewaehltes Modul: 0x%2x - ID=0x%2x     %-20s |\n", moduleNr, moduleID, ModName);
	printf("*************************************************************|\n");

	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG delib_open_first_module()
{
	ULONG moduleID;
	ULONG moduleNr;
	char ModName[30];
	ULONG handle;

	delib_get_device_nr_of_first_module(&moduleNr, &moduleID, 0);

	GetModuleName(moduleNr, ModName, sizeof(ModName));
	printf("Oeffne: Modul %x (%s)\n", moduleNr, ModName);		

	handle=DapiOpenModule(moduleNr, moduleID);

	return handle;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG check_delib_version_groesser_gleich(ULONG version)
{
	ULONG v0,v1,v2,v3;
	ULONG delib_version;
	
	
	delib_version = DapiGetDELIBVersion(0,0);

	if(delib_version < version)
	{
		v0=(version>>12) & 0xf;
		v1=(version>>8 ) & 0xf;
		v2=(version>>4 ) & 0xf;
		v3=(version>>0 ) & 0xf;

		if(v0==0)
		{
			printf("DELIB Version %x.%x%x or above is needed\n", v1, v2, v3);
		}
		else
		{
			printf("DELIB Version %x%x.%x%x or above is needed\n", v0, v1, v2, v3);
		}

		printf("please download at http://www.deditec.de/delib\n");
		printf("and install a newer driver\n");
		printf("\n");
		printf("Press any key to exit\n");
		getch();

		return(FALSE);
	}
	else return TRUE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void show_fw_version(unsigned long handle)
{
	unsigned char v0,v1,v2,v3;

	v0 = (unsigned char) DapiReadByte(handle, 0xfff4);
	IsError();
	v1 = (unsigned char) DapiReadByte(handle, 0xfff5);
	IsError();
	v2 = (unsigned char) DapiReadByte(handle, 0xfff6);
	IsError();
	v3 = (unsigned char) DapiReadByte(handle, 0xfff7);
	IsError();

	printf("FW-Version = %c%c.%c%c\n", v0,v1,v2,v3);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG check_fw_version_groesser_gleich(ULONG handle, ULONG version)
{
	ULONG fw_version;
	
	
	unsigned char v0,v1,v2,v3;

	v0 = (unsigned char) DapiReadByte(handle, 0xfff4);
	IsError();
	v1 = (unsigned char) DapiReadByte(handle, 0xfff5);
	IsError();
	v2 = (unsigned char) DapiReadByte(handle, 0xfff6);
	IsError();
	v3 = (unsigned char) DapiReadByte(handle, 0xfff7);
	IsError();

	printf("FW-Version = %c%c.%c%c\n", v0,v1,v2,v3);

	fw_version=(v0-'0')*4096 + (v1-'0')*256 + (v2-'0')*16 + (v3-'0');
	
	if(fw_version < version)
	{
		printf("Firmware-Version = %x. *** Firmware Version %x or above is needed\n", fw_version, version);
		printf("\n");
		printf("Press any key to exit\n");
		getch();

		return(FALSE);
	}
	else return TRUE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
