//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_debug.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

#include <string.h>

extern char debug_output_string[2000];
extern char debug_output_string_function_name[300];
extern char debug_output_format[300];

extern char debug_coll_buffer[200][200];
extern unsigned long debug_cnt;
extern unsigned long debug_coll_lcnt;

extern char* unicodestr_msg;
extern unsigned long unicodestr_len;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifndef PROGRAM_NAME_IGNORE
	#define PROGRAM_NAME		(char*) DapiHandle->ProgramName
#else
	#ifdef PROGRAM_NAME_INTERN
		#define PROGRAM_NAME		PROGRAM_NAME_INTERN
	#else
		#define PROGRAM_NAME		""
	#endif
#endif
	
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEBUG_OUTPUT_FORMAT				"%-30s|%-11s|"
#define debug_set_function_name(x)		if (strcmp(debug_output_string_function_name, x) != 0) {{strcpy_n(debug_output_string_function_name, sizeof(debug_output_string_function_name), x, strlen_n(x, sizeof(x))); debug_info("*************************************************************************");}}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define debug_log(x)\
{\
	strcpy(debug_output_string, "debug_output_string_function_name");\
	strcat(debug_output_string, " - ");\
	strcat(debug_output_string, x);\
	log_init("DELIB", 0);\
	log_write(debug_output_string, 0);\
}


#ifndef DEBUG_OUTPUT_TO_LOG
	#define debug_error(x)\
	{\
		strcpy_n(debug_output_string, sizeof(debug_output_string), "|DELIB|", sizeof("|DELIB|"));\
		sprintf(debug_output_format, DEBUG_OUTPUT_FORMAT, debug_output_string_function_name, "");\
		strcat_n(debug_output_string, sizeof(debug_output_string), debug_output_format, sizeof(debug_output_format));\
		strcat_n(debug_output_string, sizeof(debug_output_string), " - ", sizeof(" - "));\
		strcat_n(debug_output_string, sizeof(debug_output_string), x, sizeof(x));\
		printf("%s\n", debug_output_string);\
	}
#else
	#define debug_error(x) debug_log(x)
#endif

#ifdef DEBUG_OUTPUT
	#ifndef DEBUG_OUTPUT_TO_LOG
		#define debug_info(x)\
		{\
			strcpy_n(debug_output_string, sizeof(debug_output_string), "|DELIB|", sizeof("|DELIB|"));\
			sprintf(debug_output_format, DEBUG_OUTPUT_FORMAT, debug_output_string_function_name, "");\
			strcat_n(debug_output_string, sizeof(debug_output_string), debug_output_format, sizeof(debug_output_format));\
			strcat_n(debug_output_string, sizeof(debug_output_string), " - ", sizeof(" - "));\
			strcat_n(debug_output_string, sizeof(debug_output_string), x, sizeof(x));\
			printf("%s\n", debug_output_string);\
		}
	#else
		#define debug_info(x) debug_log(x)
	#endif
#else
	#define debug_info(x) {}
#endif


#ifdef DEBUG_OUTPUT
	#ifndef DEBUG_OUTPUT_TO_LOG
		#define debug_print(x)\
		{\
			strcpy_n(debug_output_string, sizeof(debug_output_string), "|DELIB|", sizeof("|DELIB|"));\
			sprintf(debug_output_format, DEBUG_OUTPUT_FORMAT, debug_output_string_function_name, "");\
			strcat_n(debug_output_string, sizeof(debug_output_string), debug_output_format, sizeof(debug_output_format));\
			strcat_n(debug_output_string, sizeof(debug_output_string), " - ", sizeof(" - "));\
			strcat_n(debug_output_string, sizeof(debug_output_string), x, sizeof(x));\
			printf("%s\n", debug_output_string);\
		}
	#else
		#define debug_print(x) debug_log(x)
	#endif
#else
	#define debug_print(x)	{}
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifndef DEBUG_OUTPUT_TO_LOG
	#ifdef DEBUG_OUTPUT 
		// NICHT sammeln....direkt ausgeben         
		#define debug_collect_init()		{debug_coll_lcnt=0;}
		#define debug_collect(x)			{debug_print(x);}
		#define debug_collect_printall()	{}
	#else         
		// Alles sammeln....nur bei einem Fehler ausgeben
		#define debug_collect_init()		{debug_coll_lcnt=0;}
		#define debug_collect(x)			{strcpy_n(debug_coll_buffer[debug_coll_lcnt], sizeof(debug_coll_buffer[debug_coll_lcnt]), x, sizeof(x));  debug_coll_lcnt++;}
		#define debug_collect_printall()	{\
												for(debug_cnt=0;debug_cnt!=debug_coll_lcnt;debug_cnt++)\
												{\
													debug_print(debug_coll_buffer[debug_cnt]);\
												}\
											}
	#endif 
#else
	#define debug_collect_init()		{}
	#define debug_collect(x)			debug_print(x)
	#define debug_collect_printall()	{}
#endif
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
