//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_hdlmgr.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// DEBUG OUTPUT 
//#define DEBUG_OUTPUT		1				// Ausgabe aktivieren (nur fr diese CPP-Datei)
// ACHTUNG !!!! - DAS IST HIER NICHT realisiert .....DEBUG_OUTPUT wird hier nicht benutzt !
// ------------------------------------

#define PROGRAM_NAME_IGNORE 1


// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// HandleMGR_get_handle_pointer
// HandleMGR_init_handle_buffer
// HandleMGR_show_handle_buffer
// process_attach
// process_detach
// DllMain

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include "malloc.h"
#include <string.h> // memset()

#include "proj_config.h"

#include "../usb-ftdi/ftd2xx.h"


#include "library/vc/deditec_tcp_io.h"	// muss vor die "delib_intern.h", weil hier TCP_IO drin ist
#include "library/delib/delib.h"
#include "library/delib/delib_intern.h"

#include "delib_open_close.h"

#include "WinTypes.h"
#include "delib_hdlmgr.h"

extern unsigned long DapiInternHandlePointerGet(unsigned long handleXX, ULONGLONG* xx);

// ------------------------------------
// ------------------------------------
// Declarations
// ------------------------------------
// ------------------------------------

extern char DapiSetErrorCallerParamsText[];

// ------------------------------------
// ------------------------------------
// Global Vars
// ------------------------------------
// ------------------------------------

ULONGLONG HandlePointer[HandlePointerMAX];
BOOL HandleMGRIsInit = FALSE;

// ------------------------------------
// ------------------------------------
// DELIB-DEBUG
// ------------------------------------
// ------------------------------------
//
// Function															Windows (DEBUGVIEW)			Linux
// -------------------------										----------------------		-------------------------
// DapiSetError(debug_msg)											immer						immer
// debug_error(debug_msg)											immer						immer
// debug_info(debug_msg)											immer						nur bei DEBUG_OUTPUT
// debug_info(debug_msg)											nur bei DEBUG_OUTPUT		nur bei DEBUG_OUTPUT

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_HANDLE*  DAPI_FUNCTION_PRE  HandleMGR_get_handle_pointer(ULONG nr)
{
	char debug_msg[200];
	
	return ((DAPI_HANDLE*) DAPI_PTR_SIZE HandlePointer[nr]);	
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DAPI_FUNCTION_PRE  HandleMGR_init_handle_buffer()
{
	DAPI_HANDLE *DapiHandle;
	char debug_msg[200];
	unsigned long nr;
	unsigned long i;

	DapiSetErrorCallerParamsText[0] = 0; // Init Buffer
	
	if (HandleMGRIsInit == FALSE)
	{
		// DEBUG
		debug_set_function_name("HandleMGR_init_handle_buffer");
		sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
		sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
		sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
		sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
		sprintf(debug_msg,"DELIB Version = 0x%x Sub=%d", DELIB_VERSION, DELIB_VERSION_SUB);		debug_info(debug_msg);
		sprintf(debug_msg,"Init Handle Buffer");													debug_info(debug_msg);
		// -----
	
		for(nr=0; nr != HandlePointerMAX; ++nr)
		{
			HandlePointer[nr] = 0;
		}
		
		HandleMGRIsInit = TRUE;
	}

	// DEBUG
	debug_set_function_name("HandleMGR_init_handle_buffer");
	sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
	sprintf(debug_msg,"----------------------------------------------------------------");	debug_info(debug_msg);
	// -----
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void  DAPI_FUNCTION_PRE  HandleMGR_show_handle_buffer()
{
	DAPI_HANDLE *DapiHandle;
	char debug_msg[200];
	ULONG nr;

	debug_set_function_name("HandleMGR_show_handle_buffer");

	sprintf(debug_msg,"|DELIB|--------------------HandleMGR_show_handle_buffer");
	debug_info(debug_msg);
	
	for(nr=0;nr != HandlePointerMAX; ++nr)
	{
		DapiHandle = HandleMGR_get_handle_pointer(nr);
		if (DapiHandle != NULL)	
		{
			// DEBUG
			sprintf(debug_msg,"nr=%d * moduleID=%d * moduleNr=%d", nr, DapiHandle->moduleID, DapiHandle->moduleNr);
			debug_info(debug_msg);
		}
	}

	sprintf(debug_msg,"|DELIB|--------------------HandleMGR_show_handle_buffer");
	debug_info(debug_msg);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long DapiInternHandlePointerCreate(unsigned long nr)
{
	char debug_msg[200];
	DAPI_HANDLE *DapiHandle;
	
	HandlePointer[nr] = (ULONGLONG) DAPI_PTR_SIZE malloc(sizeof(DAPI_HANDLE));
		
	DapiHandle = (DAPI_HANDLE*) DAPI_PTR_SIZE HandlePointer[nr];
	
	DapiHandle->id = delib_id;
	DapiHandle->moduleID = 0;
	DapiHandle->moduleNr = 0;
	DapiHandle->ftHandle = (FT_HANDLE) -1;
	DapiHandle->SubDevice = 0;
	DapiHandle->RS485_ModuleNr = 0;
	
	debug_set_function_name("DapiInternHandlePointerCreate");
	sprintf(debug_msg,"HandlePointer Created: dez %ld (handleXXL=0x%llx) - handle-ret=%ld", nr, HandlePointer[nr], HandlePointerSTART + nr);
	debug_info(debug_msg);

	return HandlePointerSTART + nr;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long DapiInternHandlePointerGet(unsigned long handleXX, ULONGLONG* xx)
{
	char debug_msg[200];
	unsigned long handle = handleXX - HandlePointerSTART;

	if((handleXX < HandlePointerSTART) || (handle >= HandlePointerMAX))
	{
		debug_set_function_name("DapiInternHandlePointerGet");
		sprintf(debug_msg,"ERROR **** Handle = dez %ld - NOT IN A VALID RANGE !!!!!!!!!!", handle);
		debug_info(debug_msg);

		*xx = 0;

		return RETURN_ERROR;
	}
	
	*xx = HandlePointer[handle];

	if(DapiCheckHandle((DAPI_HANDLE*) DAPI_PTR_SIZE *xx) != DAPI_ERR_NONE) 
	{
		// DEBUG
		debug_set_function_name("DapiInternHandlePointerGet");
		sprintf(debug_msg, "DapiCheckHandle - ERROR * DapiCheckHandle(DapiHandle) != 0");
		debug_error(debug_msg);
		// -----
		
		return RETURN_ERROR;
	}
	
	debug_set_function_name("DapiInternHandlePointerGet");
	sprintf(debug_msg,"function end handle=%ld(handleXXL=0x%llx)", handle, *xx);
	debug_info(debug_msg);

	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long DapiInternHandlePointerClear(unsigned long handleXX)
{
	DAPI_HANDLE *DapiHandle;
	char debug_msg[200];
	unsigned long handle = handleXX - HandlePointerSTART;

	debug_set_function_name("DapiInternHandlePointerClear");
	sprintf(debug_msg, "Clear handle (nr=dez %ld)", handle);
	debug_info(debug_msg);

	if((handleXX < HandlePointerSTART) || (handle >= HandlePointerMAX))
	{
		sprintf(debug_msg,"ERROR **** Handle = dez %ld - NOT IN A VALID RANGE !!!!!!!!!!", handle);
		debug_info(debug_msg);

		return RETURN_ERROR;
	}
	
	DapiHandle = (DAPI_HANDLE*) (DAPI_PTR_SIZE HandleMGR_get_handle_pointer(handle));
	if (DapiHandle != NULL)
	{
		free(DapiHandle);
	}
	
	HandlePointer[handle] = 0;

	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternPreventSecondCallStart()
{
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternPreventSecondCallEnd()
{
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

