//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_set_get_error.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// DEBUG OUTPUT 
//#define DEBUG_OUTPUT		1				// Ausgabe aktivieren (nur fr diese CPP-Datei)
// ACHTUNG !!!! - DAS IST HIER NICHT realisiert .....DEBUG_OUTPUT wird hier nicht benutzt !
// ------------------------------------

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// DapiSetError
// DapiClearLastError
// DapiGetLastErrorText
// DapiGetLastError

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>

#define PROGRAM_NAME_IGNORE 1

#include "proj_config.h"

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	#ifdef USE_FTDI
		#include "../usb-ftdi/ftd2xx.h"
	#endif

	#include "library/delib/delib.h"
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	#include <windows.h>
	#include "conio.h"
#endif

// ------------------------------------
// ------------------------------------
// DELIB-DEBUG
// ------------------------------------
// ------------------------------------
//
// Function															Windows (DEBUGVIEW)			Linux
// -------------------------										----------------------		-------------------------
// DapiSetError(debug_msg)											immer						immer
// debug_error(debug_msg)											immer						immer
// debug_info(debug_msg)											immer						nur bei DEBUG_OUTPUT
// debug_print(debug_msg)											nur bei DEBUG_OUTPUT		nur bei DEBUG_OUTPUT

// ------------------------------------
// ------------------------------------
// Global Vars
// ------------------------------------
// ------------------------------------
FILE *fp_log;
char DapiSetErrorCallerParamsText[1024];
unsigned long DapiSetErrorCallerParamsHandle;

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	char debug_output_string[2000];
	char debug_output_string_function_name[300];
	char debug_output_format[300];

	char debug_coll_buffer[200][200];
	unsigned long debug_cnt;
	unsigned long debug_coll_lcnt;

	char* unicodestr_msg;
	unsigned long unicodestr_len;
#endif

typedef struct xxDAPI_ERROR
{
	ULONG errorcode;
	ULONG lasterror;
	ULONG handle;
	char errortext[1000];
	char filename[255];
	ULONG suberror;
	ULONG line;
} DAPI_ERROR;

DAPI_ERROR lasterror;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiSetErrorCallerParamsSet(unsigned long handle, char* text, unsigned long text_length)
{
	DapiSetErrorCallerParamsHandle = handle;
	strcpy_n(DapiSetErrorCallerParamsText, sizeof(DapiSetErrorCallerParamsText), text, text_length);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiSetError(ULONG errorcode, ULONG suberror, char *errortext, char * filename, ULONG line)
{
	char debug_msg[1000];
	char text[1000];

	//sprintf(text, "");		// Clear Text
	text[0] = 0;

	lasterror.errorcode = errorcode;
	lasterror.lasterror = errorcode;
	lasterror.handle = DapiSetErrorCallerParamsHandle;	// zwischengespeichertes Handle

	switch(errorcode)
	{
//		case DAPI_ERR_DEVICE_NOT_FOUND:							sprintf(text, "(auto text) Device not found");		break;
//		case DAPI_ERR_COMMUNICATION_ERROR:						sprintf(text, "(auto text) Communication Error");	break;
//		case DAPI_ERR_GEN_ILLEGAL_HANDLE:							sprintf(text, "(auto text) Illegal Handle");		break;
//		case DAPI_ERR_FUNCTION_NOT_DEFINED:						sprintf(text, "(auto text) Function not defined");	break;
//		case DAPI_ERR_ILLEGAL_COM_HANDLE:						sprintf(text, "(auto text) Illegal COM-Handle");	break;
		
		case DAPI_ERR_NONE:  									sprintf(text, "(auto text)None-=0x00=DARF ES NICHT GEBEN");	break;
		//
		// ----------------------------------------------------------------------------
		// ----------------------------------------------------------------------------
		//	= 0x0100		Allgemeine Error Codes
		// ----------------------------------------------------------------------------
		// ---------------------------------------------	-------------------------------
		case DAPI_ERR_GEN_MALLOC_ERROR:  						sprintf(text, "(auto text) -GEN- malloc() error"); break;
		case DAPI_ERR_GEN_BUFFER_TOO_SMALL_ERROR:   			sprintf(text, "(auto text) -GEN- Buffer to small"); break;

		case DAPI_ERR_GEN_SOCKET_ERROR:   						sprintf(text, "(auto text) -GEN- Socket error"); break;
		case DAPI_ERR_GEN_BINDING_ERROR:   						sprintf(text, "(auto text) -GEN- Binding error"); break;
		case DAPI_ERR_GEN_SIG_HANDLER_ERROR:   					sprintf(text, "(auto text) -GEN- Signal Handler error"); break;
				
		case DAPI_ERR_GEN_UNKNOWN_ENCRYPTION_TYPE:   			sprintf(text, "(auto text) -GEN- Unknown encryption type"); break;
		case DAPI_ERR_GEN_ENCRYPTION_ERROR:   					sprintf(text, "(auto text) -GEN- Encryption error"); break;
		
		case DAPI_ERR_GEN_ILLEGAL_MODULE_ID:   					sprintf(text, "(auto text) -GEN- Illegal module-ID"); break;
		case DAPI_ERR_GEN_ILLEGAL_MODULE_NR:   					sprintf(text, "(auto text) -GEN- Illegal module-NR"); break;
		case DAPI_ERR_GEN_ILLEGAL_HANDLE:   					sprintf(text, "(auto text) -GEN- Illegal handle"); break;
		
		case DAPI_ERR_GEN_NOT_SUPPORTED_MODE:   				sprintf(text, "(auto text) -GEN- Selected mode isn't supported"); break;
		case DAPI_ERR_GEN_NOT_SUPPORTED_IO_TYPE:   				sprintf(text, "(auto text) -GEN- Selected I/O type isn't supported"); break;
		case DAPI_ERR_GEN_NOT_SUPPORTED_CHANNEL:   				sprintf(text, "(auto text) -GEN- Selected channel isn't supported"); break;
		case DAPI_ERR_GEN_NOT_SUPPORTED_SW_FEATURE:   			sprintf(text, "(auto text) -GEN- Software feature isn't supported"); break;
		case DAPI_ERR_GEN_NOT_SUPPORTED_FUNCTION:   			sprintf(text, "(auto text) -GEN- Function isn't supported"); break;
		
		//
		// ----------------------------------------------------------------------------
		// ----------------------------------------------------------------------------
		//	= 0x0200	Communication Errors
		// ----------------------------------------------------------------------------
		// ----------------------------------------------------------------------------
		case DAPI_ERR_COM_CONN_COULD_NOT_BE_ESTABLISHED:		sprintf(text, "(auto text) -COM- Connection could not be established"); break;
		case DAPI_ERR_COM_DEVICE_DID_NOT_ANSWER:   				sprintf(text, "(auto text) -COM- Device did not answer"); break;
		//
//		case DAPI_ERR_COM_HANDLE_INVALID:   					sprintf(text, "(auto text) -COM- Invalid handle"); break;
		case DAPI_ERR_COM_DELIB_ID_INVALID:   					sprintf(text, "(auto text) -COM- Invalid ID"); break;
		case DAPI_ERR_COM_FT_HANDLE_INVALID:   					sprintf(text, "(auto text) -COM- Invalid FT handle"); break;
		case DAPI_ERR_COM_FT_ERROR:   							sprintf(text, "(auto text) -COM- FT error"); break;
		//
		// ----------------------------------------------------------------------------
		// ----------------------------------------------------------------------------
		//	= 0x0300	Device Errors
		// ----------------------------------------------------------------------------
		// ----------------------------------------------------------------------------
		case DAPI_ERR_DEV_PKT_CMD_ILLEGAL:   					sprintf(text, "(auto text) -DEV_PKT- Illegal Command"); break;
		case DAPI_ERR_DEV_PKT_DATA_LENGTH_ERROR:   				sprintf(text, "(auto text) -DEV_PKT- Data length error"); break;
		case DAPI_ERR_DEV_PKT_DATA_CHECKSUM_ERROR:  			sprintf(text, "(auto text) -DEV_PKT- Data checksum error"); break;
		case DAPI_ERR_DEV_PKT_ADDR_NOT_FOR_ME:   				sprintf(text, "(auto text) -DEV_PKT- Wrong addresse"); break;
		case DAPI_ERR_DEV_PKT_OTHER_ERROR:   					sprintf(text, "(auto text) -DEV_PKT- General packet error"); break;
		//
		case DAPI_ERR_DEV_PACKET_CMD_NOT_SUPPORTED: 			sprintf(text, "(auto text) -DEV_PACKET- Command not supported"); break;
		case DAPI_ERR_DEV_PACKET_ID_1_NOT_ALLOWED:  			sprintf(text, "(auto text) -DEV_PACKET- Packet ID1 not allowed"); break;
		case DAPI_ERR_DEV_PACKET_ID_1_NOT_SUPPORTED:			sprintf(text, "(auto text) -DEV_PACKET- Packet ID1 not supported"); break;
		case DAPI_ERR_DEV_PACKET_HEADER_NOT_OK:   				sprintf(text, "(auto text) -DEV_PACKET- Packet header not ok"); break;
		case DAPI_ERR_DEV_PACKET_SUBCMD_NOT_SUPPORTED: 			sprintf(text, "(auto text) -DEV_PACKET- Subcommand not supported"); break;
		//
		case DAPI_ERR_DEV_IO_ADDR_ILLEGAL:   					sprintf(text, "(auto text) -DEV_IO- Illegal I/O addresse"); break;
		case DAPI_ERR_DEV_IO_RD_WR_ERROR:   					sprintf(text, "(auto text) -DEV_IO- I/O read/write error"); break;
		case DAPI_ERR_DEV_IO_SUB_ADDR_ILLEGAL:   				sprintf(text, "(auto text) -DEV_IO- Illegal Sub-I/O addresse"); break;
		case DAPI_ERR_DEV_IO_OTHER_ERROR:   					sprintf(text, "(auto text) -DEV_IO- Unspecified I/O error"); break;
		//
		case DAPI_ERR_DEV_FILE_WRITE_ERROR:   					sprintf(text, "(auto text) -DEV_FILE- Error while writing to file"); break;
		//
		case DAPI_ERR_DEV_CONFIG_WRITE_PROTECTED:   			sprintf(text, "(auto text) -DEV_CONFIG- Configuration is Write-Protected"); break;
		case DAPI_ERR_DEV_CONFIG_KEY_NOT_PRESSED:   			sprintf(text, "(auto text) -DEV_CONFIG- Key not pressed"); break;
		case DAPI_ERR_DEV_CONFIG_READ_ERROR:   					sprintf(text, "(auto text) -DEV_CONFIG- Read error"); break;
		case DAPI_ERR_DEV_CONFIG_WRITE_ERROR:   				sprintf(text, "(auto text) -DEV_CONFIG- Write error"); break;
		case DAPI_ERR_DEV_CONFIG_UPDATE_ERROR:   				sprintf(text, "(auto text) -DEV_CONFIG- Update error"); break;
		case DAPI_ERR_DEV_CONFIG_PARAM_ONLY_ONE_TIME_WRITEABLE: sprintf(text, "(auto text) -DEV_CONFIG- Parameter is only one time writeable"); break;
		//
		case DAPI_ERR_DEV_ENCRYPTED_HEADER_NOT_OK:   			sprintf(text, "(auto text) -DEV_ENCRYPT- Encrypted header not ok"); break;
		case DAPI_ERR_DEV_ENCRYPTION_ERROR:   					sprintf(text, "(auto text) -DEV_ENCRYPT- Encryption error"); break;
		case DAPI_ERR_DEV_ENCRYPTION_TEMP_ADMIN_MODE_NOT_ALLOWED:sprintf(text, "(auto text) -DEV_ENCRYPT- Temporary admin mode is not allowed"); break;
		case DAPI_ERR_DEV_ENCRYPTION_NO_ADMIN_RIGHTS: 			sprintf(text, "(auto text) -DEV_ENCRYPT- No admin rights"); break;
		//
		case DAPI_ERR_DEV_EXECUTE_CMD_ERROR: 					sprintf(text, "(auto text) -DEV_EXECUTE- Execute Command error"); break;

		default:												sprintf(text, "(auto text) unknown errorcode");		break;
	}
	
	// DEBUG
	//debug_set_function_name("DapiSetError");
	// Darf hier nicht rein, sonst sieht man nicht, woher der Error kam !

	sprintf(lasterror.errortext, "%s", text);
	
	if(errortext != NULL)
	{
		strcat_n(lasterror.errortext, sizeof(lasterror.errortext), "\n", 1);
		strcat_n(lasterror.errortext, sizeof(lasterror.errortext), errortext, strlen_n(errortext, sizeof(errortext)));
	}

	strcat_n(lasterror.errortext, sizeof(lasterror.errortext), "\n", 1);
	strcat_n(lasterror.errortext, sizeof(lasterror.errortext), DapiSetErrorCallerParamsText, strlen_n(DapiSetErrorCallerParamsText, sizeof(DapiSetErrorCallerParamsText)));

	sprintf(debug_msg, "%s - strlen(lasterror.errortext)=%ld", text, strlen_n(lasterror.errortext, -1));
	debug_error(debug_msg);

	sprintf(debug_msg, "Call: %s", DapiSetErrorCallerParamsText);
	debug_error(debug_msg);

	sprintf(debug_msg, "errorcode = 0x%x.0x%x * filename = %s * line = %d", (unsigned int) errorcode, (unsigned int) suberror, filename, (unsigned int) line);
	debug_error(debug_msg);
	
	sprintf(debug_msg, "Autotext: %s", text);
	debug_error(debug_msg);
	
	if(errortext != NULL)
	{
		sprintf(debug_msg, "Errortext from Seterror: %s",errortext);
		debug_error(debug_msg);
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiClearLastError()
{
	lasterror.lasterror=0;
	lasterror.errorcode=0;
	lasterror.handle=0;
	
	return;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetLastErrorText(UCHAR *msg_ret, ULONG msg_length)
{
	ULONG i;
	char debug_msg[1000];

	// DEBUG
	debug_set_function_name("DapiGetLastErrorText");
	
	sprintf(debug_msg, "(msg_length=%d)", (unsigned int) msg_length);
	debug_error(debug_msg);
	sprintf(debug_msg, "lasterror.errortext=%s * strlen=%ld",  (char*) lasterror.errortext, strlen_n(lasterror.errortext, sizeof(lasterror.errortext)));
	debug_error(debug_msg);
	// -----
	
	for(i=0;i!=strlen_n(lasterror.errortext, sizeof(lasterror.errortext));++i)
	{
		if(i<msg_length)
		{
			*(msg_ret + i) = *(lasterror.errortext + i);
		}
	}

	if(i<msg_length) 
	{
		*(msg_ret + i) = 0;
	}
	else
	{
		*(msg_ret + msg_length - 1) = 0;
	}
	
	return lasterror.handle;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetLastError()
{
	return lasterror.lasterror;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
