//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	dt_communication_paramams.h
//	project: DELIB
//
//
//	(c) DEDITEC GmbH, 2009-2020
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
// ----------------------------------------------------------------------------
#define DT_FTDI_USB_CMD_PING								0x12
#define DT_FTDI_USB_CMD_SEND8BYTE							0x23
#define DT_FTDI_USB_CMD_GET8BYTE							0x34
#define DT_FTDI_USB_CMD_SENDNBYTE							0x45
#define DT_FTDI_USB_CMD_GETNBYTE							0x56

// ----------------------------------------------------------------------------
#define CAN_CMD_REG_READ									0x10
#define CAN_CMD_REG_WRITE									0x20
#define CAN_CMD_BOOTLOAD_READ								0x30
#define CAN_CMD_BOOTLOAD_WRITE								0x40
#define CAN_CMD_GET_INFO									0xf0

// ----------------------------------------------------------------------------
#define CAN_DATA_NOTHING									0x00
#define CAN_DATA_BIT										0x01
#define CAN_DATA_BYTE										0x02
#define CAN_DATA_WORD										0x03
#define CAN_DATA_LONG										0x04

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// TCP-IP und BC Parameter
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ------------------------------------
#define DEDITEC_EMBEDDED_BC_PORT							9912
#define DEDITEC_DEFAULT_TCP_PORT_NO							9912

#define DEDITEC_DEFAULT_SNMP_PORT							161
#define DEDITEC_DEFAULT_SNMP_TRAP_PORT						162

// ------------------------------------
// TCP TX and RX ID's
#define DEDITEC_TCP_PACKET_ID_0								0x63
#define DEDITEC_TCP_PACKET_ID_1_NORMAL						0x9a
#define DEDITEC_TCP_PACKET_ID_1_ENCRYPT_NORMAL				0x9b
#define DEDITEC_TCP_PACKET_ID_1_ENCRYPT_ADMIN				0x9c
#define DEDITEC_TCP_PACKET_ID_1_ENCRYPT_ADMIN_TEMP			0x9d

#define DEDITEC_TCP_PACKET_ID_2_CMD_RO_1					0x01
#define DEDITEC_TCP_PACKET_ID_2_CMD_RO_BIG					0x02
#define DEDITEC_TCP_PACKET_ID_2_CMD_SEND_FILE				0x03
#define DEDITEC_TCP_PACKET_ID_2_CMD_SPECIAL					0x04

#define DEDITEC_TCP_PACKET_ID_2_ANSWER_RO_1					0x81
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_RO_BIG				0x82
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_CMD_SEND_FILE		0x83
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_CMD_SPECIAL			0x84

// ------------------------------------
#define DEDITEC_TCPSPECIAL_CMD_CMD_LINUX_INSTALL_UPD		0x0001
#define DEDITEC_TCPSPECIAL_CMD_CMD_BOOTLDR_DATA				0x0002
#define DEDITEC_TCPSPECIAL_CMD_PARAMETER_READ				0x524e	//RN
#define DEDITEC_TCPSPECIAL_CMD_PARAMETER_WRITE				0x574e	//WN
#define DEDITEC_TCPSPECIAL_CMD_IDENTIFY						0x0003
#define DEDITEC_TCPSPECIAL_CMD_ACTIVATE_ADMIN_TEMP			0x0004
#define DEDITEC_TCPSPECIAL_CMD_RELOAD_ETH_CONFIG			0x0005
#define DEDITEC_TCPSPECIAL_CMD_GET_CURRENT_CONFIG			0x0006
#define DEDITEC_TCPSPECIAL_CMD_SET_MAC_ADDR					0x0007
#define DEDITEC_TCPSPECIAL_CMD_GET_MAC_ADDR					0x0008
#define DEDITEC_TCPSPECIAL_CMD_READ_EE_DIRECTORY			0x0009
#define DEDITEC_TCPSPECIAL_CMD_WRITE_EE_DIRECTORY			0x000a
#define DEDITEC_TCPSPECIAL_CMD_SET_RTC						0x000b
#define DEDITEC_TCPSPECIAL_CMD_GET_RTC						0x000c
#define DEDITEC_TCPSPECIAL_CMD_SUBMODULE_BUFFER_CMD			0x000d
#define DEDITEC_TCPSPECIAL_CMD_RESTORE_EEPROM_DEFAULT		0x000e

// ------------------------------------
#define CONNECTION_TIMEOUT_TO_CLIENT 						5
// timeout value in seconds; server closes connection to client after x seconds

// ------------------------------------
#define DEDITEC_TCP_START_ID_FOR_MULTIPLE_BYTE_DATA			35

// ------------------------------------
// Broadcast TX and RX ID's

#define DEDITEC_BC_PACKET_TX_ID_0 							0x12
#define DEDITEC_BC_PACKET_TX_ID_1 							0x47
#define DEDITEC_BC_PACKET_TX_ID_2 							0x22
#define DEDITEC_BC_PACKET_TX_ID_3 							0x01

#define DEDITEC_BC_PACKET_RX_ID_0 							0x13
#define DEDITEC_BC_PACKET_RX_ID_1 							0x47
#define DEDITEC_BC_PACKET_RX_ID_2 							0x22
#define DEDITEC_BC_PACKET_RX_ID_3 							0x01

#define DEDITEC_BC_PACKET_CMD_GLOBAL_CALL					0x01
#define DEDITEC_BC_PACKET_CMD_PARAM_GET						0x02
#define DEDITEC_BC_PACKET_CMD_PARAM_SET						0x03
#define DEDITEC_BC_PACKET_CMD_ETH0_CONFIGURE				0x04
#define DEDITEC_BC_PACKET_CMD_GLOBAL_CALL_WITH_DEV_CFG		0x05

#define DEDITEC_BC_PACKET_PARAM_BOARD_NAME					0x01
#define DEDITEC_BC_PACKET_PARAM_IP_ADDR						0x02
#define DEDITEC_BC_PACKET_PARAM_NETMASK						0x03
#define DEDITEC_BC_PACKET_PARAM_STDGATEWAY					0x04
#define DEDITEC_BC_PACKET_PARAM_DNS1						0x05
#define DEDITEC_BC_PACKET_PARAM_DHCP						0x06
#define DEDITEC_BC_PACKET_PARAM_DELIB_MODULE_ID				0x07
#define DEDITEC_BC_PACKET_PARAM_MAC_ADDR					0x08
#define DEDITEC_BC_PACKET_PARAM_INFO_STRING					0x09
#define DEDITEC_BC_PACKET_PARAM_TCP_CONFIG_USED				0x0a
#define DEDITEC_BC_PACKET_PARAM_KEY_HANDLER_LOG				0x0b
#define DEDITEC_BC_PACKET_PARAM_IDENTIFY					0x0c
#define DEDITEC_BC_PACKET_PARAM_TCP_PORT					0x0d
#define DEDITEC_BC_PACKET_PARAM_ACTIVATE_AUTH_KEY			0x0e

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Encryption
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEDITEC_ENCRYPTION_TEMPORARY_ADMIN_PW				"!?d3d1t3c!?4711!?"
#define DEDITEC_ENCRYPTION_NORMAL_DEFAULT_PW				"normal"
#define DEDITEC_ENCRYPTION_ADMIN_DEFAULT_PW					"admin"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// CANopen
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEDITEC_CO_VENDOR_ID								0x44f
#define DEDITEC_CO_BL_ID                                  	0x424f4f54
#define DEDITEC_CO_SN_PREFIX								0x6474	// "dt"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// RO-Modules-REGISTER
// --------------------
// Registerbelegung:
// Register 0x00-0x0f (write)- Ausgnge
// Register 0x00-0x0f (read) - Ausgnge zurcklesen

// Register 0x20-0x2f (read)- Eingnge
// Register 0x40-0x4f (read)- Eingangs-FF's (incl. Zurcksetzen)

// Register 0xf0 - Config Timeout (0=disabled, 1-255 sind Zeit-Werte)
// Register 0xf1 - Config ???

// Register 0xfff8-fffe	8Bit readback Register (zum Test)
// Register 0xfff4-fff7		32 Bit Firmware-Version
// Register 0xfff0-fff3		32 Bit SW-Feature Bits (Type of Software Features)
// Register 0xffec-ffef		32 Bit HW-Feature Bits (Type of Hardware)
// Register 0xff00-ff01		16 Bit No of DO Chan 
// Register 0xff02-ff03		16 Bit No of DI Chan 
// Register 0xff04-ff05		16 Bit No of DX Chan 
// Register 0xff06-ff07		16 Bit No of AD Chan 
// Register 0xff08-ff09		16 Bit No of DA Chan 
// Register 0xff0a-ff0b		16 Bit No of Stepper Chan 

// 0xffd0-df		: Gibt die Modul-Identifikations-Nummer des Moduls zurck
// Fr den Direktzugriff auf die einzelnen Module

// 0xfe00			: Modul-Nummer, auf die geschrieben werden soll
// 0xfe02			: Register, auf das geschrieben werden soll
// 0xfe03			: Daten, die geschrieben werden sollen 
// 0xfe04+5			: Daten, die gelesen werden

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// 8 Bytes CAN-Data Command zum Modul
// ----------------------------------
// 1.Byte = Command
// 2.Byte = Register Bit 0-7
// 3.Byte = Register Bit 8-15
// 4.Byte = JOB-ID
// 5.Byte = Data (0-7)
// 6.Byte = Data (8-15)
// 7.Byte = Data (16-23)
// 8.Byte = Data (24-31)

// Command = (0x10=read,0x20=write,0xf0=get info) 	OR gewnschte Datenbits (0=nix,1=Bit,2=Byte,3=Word,4=Long)

// 8 Bytes CAN-Data ANTWORT vom Modul
// ----------------------------------
// 1.Byte = 1 = OK, 0xfd=JOB-ID nochmals vorhanden, 0xfe Befehl ungltig
// 2.Byte = Was ist an EMPFANGENEN Daten gltig (0=nix, 1=Bit, 2=Byte, 3 Word, 4=Long)
// 3.Byte = JOB-ID
// 4.Byte = Data (0-7)
// 5.Byte = Data (8-15)
// 6.Byte = Data (16-23)
// 7.Byte = Data (24-31)


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// Protokoll fr Serielle Kommandos
//								Daten 	*	Seriell bertragen in hex	*	ASCII
// 1.Zeichen = <SOH>			<SOH>	*	0x01						*	<SOH>
// 2.Zeichen = MODUL-NR			0x34	*	0x33, 0x34					*	(34)
// 2.Zeichen = JOB-ID			0x12	*	0x31, 0x32					*	(12)
// 3.Zeichen = COMMAND			'W'		*	0x57						*	(W)
// 3.Zeichen = WIDTH			'B'		*	0x42						*	(B)
// 4.Zeichen = Adresse			0x00	*	0x30, 0x30					*	(00)
// 5.Zeichen = Adresse			0x12	*	0x31, 0x32					*	(12)
// 6.Zeichen = Daten			0x0f	*	0x30, 0x46					*	(0F)
// 7.Zeichen = Checksumme		Summe	*	0x33, 0x41					*	(3A) (Summe=0x23a -> (nur 8 Bit -> 0x3a)
// 8.Zeichen = <CR>				0x0d	*	0x0d						*	<CR>


// COMMAND'S : W = write, R=read
// Command=W,R greift auf Register zu

// WIDTH= B -> Byte		(-> es folgen 2 Bytes fr Daten)
// WIDTH= W -> 16 Bit	(-> es folgen 4 Bytes fr Daten)
// WIDTH= L -> 32 Bit	(-> es folgen 8 Bytes fr Daten)
// WIDTH= X -> 64 Bit	(-> es folgen 16 Bytes fr Daten)
// WIDTH= M -> 128 Bit	(-> es folgen 32 Bytes fr Daten)

//#define SERIELL_CMD_WIDTH_8								'B'
//#define SERIELL_CMD_WIDTH_16								'W'
//#define SERIELL_CMD_WIDTH_32								'L'
//#define SERIELL_CMD_WIDTH_64								'X'
//#define SERIELL_CMD_WIDTH_128								'M'

//#define ERR_EXECUTE_RS232_RX_COMMAND_OK					0
//#define ERR_EXECUTE_RS232_RX_COMMAND_ILLEGAL_COMMAND		1
//#define ERR_EXECUTE_RS232_RX_COMMAND_WRONG_DATA_LENGTH	2
//#define ERR_EXECUTE_RS232_RX_COMMAND_WRONG_CHECKSUM		3
//#define ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME			4

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// RO-SPI->CPU Commands
#ifndef PRODUCT_GROUP_NET
#define RO_CPU_CMD_MODULE_COUNTER_LATCH						0x7c		// Latch Counter, if Data = 0x3a
#define RO_CPU_CMD_MODULE_COUNTER_LATCH_VALUE				0x3a		// Latch Counter, if Data = 0x3a
#define RO_CPU_CMD_MODULE_COUNTER_LATCH_WITH_RESET_VALUE	0x3d		// Latch Counter WITH RESET , if Data = 0x3d

#define RO_CPU_CMD_MODULE_TIMEOUT_SHUT_OFF					0x7d		// Deactivate Module, if Data = 0x49
#define RO_CPU_CMD_MODULE_TIMEOUT_SHUT_OFF_VALUE			0x49		// Deactivate Module, if Data = 0x49

#define RO_CPU_CMD_WRITE_TO_BOOTLOADER						0x7e		// Write data to bootloader
#endif

#define RO_CPU_CMD_GO_BOOTLOADER							0x7f		// Jump to Bootloader if Data = 0x83
#define RO_CPU_CMD_GO_BOOTLOADER_VALUE						0x83		// Jump to Bootloader if Data = 0x83

#define RO_CPU_CMD_OPTION_FILTER							0x78		// 0=disable filter / 1..2..3..4 = Filter Level

#define RO_CPU_CMD_FIFO_WRITE_ADDR_REG						0x76		// Write to Fito-Addr reg
#define RO_CPU_CMD_FIFO_WRITE_FIFO_CMD						0x77		// Write Fifo Command and execute this command

#ifndef PRODUCT_GROUP_NET

#define RO_CPU_CMD_OPTION_PWM_FREQ_SET						0x78		// 0=default (1kHz) / 1..2..3..4 = Filter Level
#define RO_CPU_CMD_OPTION_PWM_FREQ_READBACK					0x84		// 0=default (1kHz) / 1..2..3..4 = Filter Level

#define RO_CPU_CMD_SET_EEPROM_DATA							0x79		// Set EEPROM Data
#define RO_CPU_CMD_SET_EEPROM_ADRESSL						0x7a		// Set EEPROM AdressLow
#define RO_CPU_CMD_SET_EEPROM_ADRESSH						0x7b		// Set EEPROM AdressHigh + Initiere EEPROM Write
#define RO_CPU_CMD_GET_EEPROM_STATUS						0x7c		// Set EEPROM AdressHigh + Initiere EEPROM Write
#endif

#define RO_CPU_CMD_FIFO_GET_ADDR_REG						0xf0		// Get Fifo Status
#define RO_CPU_CMD_FIFO_GET_CMD_ANSW						0xf1		// Get Fifo Status
#define RO_CPU_CMD_FIFO_GET_STATUS							0xf2		// Get Fifo Status
#define RO_CPU_CMD_FIFO_READ_DATA							0xf3		// Get Fifo Data

#ifndef PRODUCT_GROUP_NET
#define RO_CPU_CMD_GET_ERROR_CODE							0xf6		// Get ERROR Code
#define RO_CPU_CMD_GET_FIRMWARE_ID							0xf7		// Get Firmware ID

#define RO_CPU_CMD_GET_V0									0xf8		// Get Version Nr 0
#define RO_CPU_CMD_GET_V1									0xf9		// Get Version Nr 1
#define RO_CPU_CMD_GET_V2									0xfa		// Get Version Nr 2
#define RO_CPU_CMD_GET_V3									0xfb		// Get Version Nr 3

#define RO_CPU_CMD_GET_ID									0xfc		// Get Module-ID Info

#define RO_CPU_CMD_GET_CONFIG								0xfd		// Bit 0 = Bootloader, Bit 1 = OP_X2 Bit 

#define RO_CPU_CMD_READ_FROM_BOOTLOADER						0xfe		// Give back data from bootloader
#define RO_CPU_CMD_GIVE_BACK								0xff		// Give the written Data back

// ----------------------------------------------------------------------------

#define RO_COMM_RETURN_OK 									0x01
#define RO_COMM_RETURN_REG_INVALID							0xfe
#define RO_COMM_RETURN_ERROR 								0xff

// ----------------------------------------------------------------------------
// Bootloader-ID (8-Bit)
#define RO_BOOTLOAD_ID_RO_SER								0x00
#define RO_BOOTLOAD_ID_RO_CAN								0x01
#define RO_BOOTLOAD_ID_RO_AD16DA4							0x02
#define RO_BOOTLOAD_ID_RO_DA2_ISO							0x03
#define RO_BOOTLOAD_ID_RO_STEPPER2							0x04
#define RO_BOOTLOAD_ID_RO_Ox_Rx								0x05
#define RO_BOOTLOAD_ID_RO_PT100								0x06
#define RO_BOOTLOAD_ID_RO_CNT8								0x07

#define DT_BOOTLOAD_ID_USB_TTL_64							0x80
#define RO_BOOTLOAD_ID_RO_USB2								0x81

#define DT_BOOTLOAD_ID_STM2_ETH								0x82

// ----------------------------------------------------------------------------
// RO-SPI Commands
#define RO_CPU_ID_DA2										1
#define RO_CPU_ID_AD16_DA4									2
#define RO_CPU_ID_AD16										3
#define RO_CPU_ID_DA4										4
#define RO_CPU_ID_AD16_ISO									5
#define RO_CPU_ID_STEPPER2									6
#define RO_CPU_ID_O8_R8										7
#define RO_CPU_ID_PT100										8
#define RO_CPU_ID_CNT_8										9
#define RO_CPU_ID_CNT_IGR									10
#define RO_CPU_ID_DA8										11
#define RO_CPU_ID_MOS16										12
#define RO_CPU_ID_MOS16_PWM									13
#define RO_CPU_ID_R8_UM										14

#define RO_CPU_ID_OUTPUT									0xf0
#define RO_CPU_ID_INPUT										0xf1
// ----------------------------------------------------------------------------
#endif

// RO-FIFO Commands
#define RO_FIFO_CMD_fifo_init 								1
#define RO_FIFO_CMD_fifo_set_intervalL						2
#define RO_FIFO_CMD_fifo_set_intervalH						3
#define RO_FIFO_CMD_fifo_enable_chL							4
#define RO_FIFO_CMD_fifo_enable_chH							5
#define RO_FIFO_CMD_fifo_enable_disable						6

// RO-FIFO Status
#define RO_FIFO_STATUS_MASK_MEASURE_ENABLED	 				0x80
#define RO_FIFO_STATUS_MASK_TEST_DATA		 				0x40
#define RO_FIFO_STATUS_MASK_OVERFLOW		 				0x20
#define RO_FIFO_STATUS_MASK_UNDERRUN		 				0x10
#define RO_FIFO_STATUS_FULL_256_BYTE		 				0x08
#define RO_FIFO_STATUS_FULL_64_BYTE			 				0x04
#define RO_FIFO_STATUS_FULL_16_BYTE			 				0x02
#define RO_FIFO_STATUS_FULL_1_BYTE			 				0x01

#define RO_FIFO_ID_START									0xf0
#define RO_FIFO_ID_END										0xf1
#define RO_FIFO_ID_TYPE_TEST1								0xfe
#define RO_FIFO_ID_TYPE_AD16M0								0x01

// ----------------------------------------------------------------------------

// Special Functions
#define SPECIAL_COMMAND_FLASH_ERASE_0						1
#define SPECIAL_COMMAND_FLASH_ERASE_1						2
#define SPECIAL_COMMAND_REBOOT								3
#define SPECIAL_COMMAND_RESCAN								4
#define SPECIAL_COMMAND_TEST_A								5
#define SPECIAL_COMMAND_TEST_B								6
#define SPECIAL_COMMAND_TEST_C								7
#define SPECIAL_COMMAND_SUBMOD_BUFF_CMD						8

// Special CAN Command Functions
#define SPECIAL_CAN_CMD_RELOAD_CFG							1

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ------------------------------------
// NET-CAN-Commands
// ------------------------------------
// Config Commands
#define NET_CAN_D0_CFG											0x01
//
#define NET_CAN_D1_CFG_CONFIG_CLR_ALL_MODULE_ID					0x01
#define NET_CAN_D1_CFG_CONFIG_OUT_INACTIVE						0x10
#define NET_CAN_D1_CFG_CONFIG_OUT_ACTIVE						0x11
#define NET_CAN_D1_CFG_CONFIG_SET_MODULE_ID						0x20
// ------------------------------------
// Global Commands for all Submodules
#define NET_CAN_D0_GLOBAL_CALL									0x02
//
#define NET_CAN_D1_GLOB_CLR_5000								0x01
#define NET_CAN_D1_GLOB_SHUT_OFF_OUTPUTS						0x10
#define NET_CAN_D1_GLOB_CNT_LATCH_ALL							0x20
#define NET_CAN_D1_GLOB_CNT_LATCH_ALL_WITH_RESET				0x21
// ------------------------------------


// NET-INTERCOMM-Commands
#define NET_INTERCOM_CMD_GET_FW_ID_0							0xfff6		// Get Firmware ID
#define NET_INTERCOM_CMD_GET_FW_ID_1							0xfff7		// Get Firmware ID

#define NET_INTERCOM_CMD_GET_V0									0xfff8		// Get Version Nr 0
#define NET_INTERCOM_CMD_GET_V1									0xfff9		// Get Version Nr 1
#define NET_INTERCOM_CMD_GET_V2									0xfffa		// Get Version Nr 2
#define NET_INTERCOM_CMD_GET_V3									0xfffb		// Get Version Nr 3

#define NET_INTERCOM_CMD_GET_ID_0								0xfffc		// Get Module-ID Info
#define NET_INTERCOM_CMD_GET_ID_1								0xfffd		// Get Module-ID Info

#define NET_INTERCOM_CMD_GET_CONFIG								0xfffe		// Bit 0 = Bootloader, Bit 1 = OP_X2 Bit


// NET-SUBMODULE-ID's
#define NET_DEV_ID_O8_R8										0x7e10
#define NET_DEV_ID_OPTO16										0x7e11
#define NET_DEV_ID_REL16										0x7e12
#define NET_DEV_ID_REL16_NEU									0x7e13
//#define NET_DEV_ID_REL8_UM									0x7e13
#define NET_DEV_ID_REL4_10A										0x7e14
#define NET_DEV_ID_REL8_SAFE									0x7e15
#define NET_DEV_ID_MOS16										0x7e16
#define NET_DEV_ID_MOS16_PWM									0x7e17
#define NET_DEV_ID_DIO8											0x7e18

#define NET_DEV_ID_AD2_18										0x7e20
#define NET_DEV_ID_AD2_16										0x7e21
#define NET_DEV_ID_DA2_ISO										0x7e22
#define NET_DEV_ID_DA4_8										0x7e23
#define NET_DEV_ID_AD16_16										0x7e30
#define NET_DEV_ID_AD16_18										0x7e31

#define NET_DEV_ID_TEMP4										0x7e24

// NET-SUBMODULE-Bootloader-ID's
#define NET_BOOTLOAD_DEV_ID_DI_DO								0xfe10
#define NET_BOOTLOAD_DEV_ID_AD_DA								0xfe11
#define NET_BOOTLOAD_DEV_ID_TEMP								0xfe12
#define NET_BOOTLOAD_DEV_ID_AD16								0xfe13

// COS-MODULE-Bootloader-ID - PRE
#define COS_BOOTLOAD_DEV_ID_PRE									0x01020000

// ------------------------------------
// Submodule Commands for execute_submod_buff_cmd
#define NET_SUBMOD_EXEC_CMD_WRITE_EE_DIRECTORY					0x0001
#define NET_SUBMOD_EXEC_CMD_READ_EE_DIRECTORY					0x0002
#define NET_SUBMOD_EXEC_CMD_CREATE_EE_DIRECTORY					0x0003

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEV_A31_24_GROUP_DI										0x01000000
#define DEV_A23_16_GROUP_DI_SUB_DI_RD_DATA8_TO_64				0x00100000		// 8, 16, 32 oder 64 bit - je nachdem wie die untersten 3 bits der addr sind
#define DEV_A23_16_GROUP_DI_SUB_DI_READ_FF						0x00110000
//#define DEV_A23_16_GROUP_DI_SUB_DI_RW_FF_FILTER					0x00120000
#define DEV_A23_16_GROUP_DI_SUB_CNT_READ_16						0x00200000
#define DEV_A23_16_GROUP_DI_SUB_CNT_READ_WITH_CLR_16			0x00210000
#define DEV_A23_16_GROUP_DI_SUB_CNT_READ_LATCH_16				0x00220000

#define DEV_A31_24_GROUP_DO										0x02000000
#define DEV_A23_16_GROUP_DO_SUB_DO_RW_DATA8_TO_64				0x00100000		// 8, 16, 32 oder 64 bit - je nachdem wie die untersten 3 bits der addr sind
#define DEV_A23_16_GROUP_DO_SUB_DO_CLEAR_BIT					0x00110000
#define DEV_A23_16_GROUP_DO_SUB_DO_SET_BIT						0x00120000
#define DEV_A23_16_GROUP_DO_SUB_PWM_RW_DATA						0x00200000
#define DEV_A23_16_GROUP_DO_SUB_PWM_RW_FREQ						0x00210000
#define DEV_A23_16_GROUP_DO_SUB_DO_WITH_TIMER					0x00300000


#define DEV_A31_24_GROUP_CNT8									0x04000000
#define DEV_A23_16_GROUP_CNT8_SUB_CNT_RW_MODE					0x00100000
#define DEV_A23_16_GROUP_CNT8_SUB_CNT_RD_32						0x00110000
#define DEV_A23_16_GROUP_CNT8_SUB_CNT_RD_48						0x00120000


#define DEV_A31_24_GROUP_AD										0x10000000
//#define DEV_A23_16_GROUP_AD_SUB_AD_RD_DATA						0x00100000
#define DEV_A23_16_GROUP_AD_SUB_AD_RW_MODE						0x00110000
#define DEV_A23_16_GROUP_AD_SUB_AD_RD_DATA_AND_MODE				0x00120000
#define DEV_A23_16_GROUP_AD_SUB_AD_RW_FILTER					0x00130000


#define DEV_A31_24_GROUP_DA										0x20000000
#define DEV_A23_16_GROUP_DA_SUB_DA_RW_DATA						0x00100000
#define DEV_A23_16_GROUP_DA_SUB_DA_RW_MODE						0x00110000
#define DEV_A23_16_GROUP_DA_SUB_DA_RD_DATA_AND_MODE				0x00120000

#define DEV_A31_24_GROUP_TEMP									0x40000000
#define DEV_A23_16_GROUP_TEMP_SUB_RD_DATA						0x00100000
#define DEV_A23_16_GROUP_TEMP_SUB_RD_RESISTOR					0x00110000

#define DEV_A31_24_GROUP_CUST1									0xF0000000

// ------------------------------------
// Submodule Commands for execute_submod_buff_cmd
// Es stehen die untersten 3 Bit zur Verfgung ....
#define DEV_A07_00_LENGTH_LONGLONG								0x00000004
#define DEV_A07_00_LENGTH_LONG									0x00000000
#define DEV_A07_00_LENGTH_WORD									0x00000001
#define DEV_A07_00_LENGTH_BYTE									0x00000002
#define DEV_A07_00_LENGTH_BIT									0x00000003


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// FLASH Filesystem
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


#define DT_STM2_1M_FLASH_FW_START_OFFSET					0x08020400
#define DT_STM2_1M_FLASH_WWW_FS_OFFSET						0x08080000
#define DT_STM2_1M_FLASH_WWW_FS_SIZE						0x00080000

// Filesystem ID
#define DT_STM2_1M_FLASH_WWW_FS_ID							0x87654321


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// EEPROM Filesystem
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ------------------------------------
// Filesystem ID
#define DT_EE_FILESYSTEM_ID									0x95acd43f
#define DT_WWW_FS_FLASH_ID									0x87654321

// ------------------------------------
// Filesystem Directory Types
// Achtung: 0x01 .. 0x0F (+ 0x80 MAC addr) ist Config Bereich -> wird NIE gelscht!

#define DT_EE_FILESYSTEM_DIR_TYPE_EMPTY						0xff
#define DT_EE_FILESYSTEM_DIR_TYPE_CONFIG					0x01
#define DT_EE_FS_DIR_TYPE_SERIALNUMBER						0x02
#define DT_EE_FS_DIR_TYPE_CUSTOM_DATA						0x05

#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_DEV_CFG				0x10
#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_RX_CFG				0x11
#define DT_EE_FILESYSTEM_DIR_TYPE_CAN_TX_CFG				0x12

#define DT_EE_FILESYSTEM_DIR_TYPE_SER_DEV_CFG				0x20

#define DT_EE_FILESYSTEM_DIR_TYPE_SUBMODULE_DEFAULT_VALUES	0x30
#define DT_EE_FILESYSTEM_DIR_TYPE_SUBMODULE_IO_NAMES		0x31

//#define DT_EE_FS_DIR_TYPE_CANOPEN_GEN						0x40
#define DT_EE_FS_DIR_TYPE_CANOPEN_COM						0x41
//#define DT_EE_FS_DIR_TYPE_CANOPEN_MAN						0x42
#define DT_EE_FS_DIR_TYPE_CANOPEN_APP						0x43

#define DT_EE_FS_DIR_TYPE_GUARD_JOB							0x50
#define DT_EE_FS_DIR_TYPE_GUARD_ACTION						0x51

#define DT_EE_FILESYSTEM_DIR_TYPE_MAC_ADDR					0x80
#define DT_EE_FILESYSTEM_DIR_TYPE_ETH_CFG					0x81
#define DT_EE_FILESYSTEM_DIR_TYPE_BOARD_NAME				0x82
#define DT_EE_FILESYSTEM_DIR_TYPE_IO_NAMES					0x83
#define DT_EE_FILESYSTEM_DIR_TYPE_IO_CONFIG					0x84
#define DT_EE_FILESYSTEM_DIR_TYPE_ENCRYPTION				0x85
#define DT_EE_FILESYSTEM_DIR_TYPE_NTP						0x86
#define DT_EE_FILESYSTEM_DIR_TYPE_MAIL						0x87
#define DT_EE_FILESYSTEM_DIR_TYPE_HTTP						0x88
#define DT_EE_FILESYSTEM_DIR_TYPE_USR_MGR_CFG				0x89

// ------------------------------------
// Filesystem Directory Sizes

#define DT_EE_FS_DIR_TYPE_CONFIG_SIZE						32
#define DT_EE_FS_DIR_SIZE_CUSTOM_DATA						68
#define DT_EE_FS_DIR_SIZE_SERIALNUMBER						4

#define DT_EE_FS_DIR_TYPE_CAN_DEV_CFG_SIZE					64
#define DT_EE_FS_DIR_TYPE_CAN_RX_CFG_SIZE					64
#define DT_EE_FS_DIR_TYPE_CAN_TX_CFG_SIZE					64
#define DT_EE_FS_DIR_TYPE_SER_DEV_CFG_SIZE					8

//#define DT_EE_FS_DIR_SIZE_CANOPEN_GEN						8
#define DT_EE_FS_DIR_SIZE_CANOPEN_COM						540
//#define DT_EE_FS_DIR_SIZE_CANOPEN_MAN						84
#define DT_EE_FS_DIR_SIZE_CANOPEN_APP						484

#define DT_EE_FS_DIR_SIZE_GUARD_JOB							128
#define DT_EE_FS_DIR_SIZE_GUARD_ACTION						128

#define DT_EE_FS_DIR_TYPE_SUBMODULE_DEFAULT_VALUES_SIZE		336
#define DT_EE_FS_DIR_TYPE_SUBMODULE_IO_NAMES_SIZE			256

#define DT_EE_FS_DIR_TYPE_MAC_ADDR_SIZE						6
#define DT_EE_FS_DIR_TYPE_ETH_CFG_SIZE						18
#define DT_EE_FS_DIR_TYPE_BOARD_NAME_SIZE					64
#define DT_EE_FS_DIR_TYPE_IO_NAMES_SIZE						1024
#define DT_EE_FS_DIR_TYPE_IO_CONFIG_SIZE					18
#define DT_EE_FS_DIR_TYPE_ENCRYPTION_SIZE 					36
#define DT_EE_FS_DIR_TYPE_NTP_SIZE 							40
#define DT_EE_FS_DIR_TYPE_MAIL_SIZE							82
#define DT_EE_FS_DIR_TYPE_USR_MGR_CFG_SIZE					36

// ------------------------------------
// Filesystem Directory Attributes
/*
#define DT_EE_FILESYSTEM_DIR_ATTR_READ_ONLY					(1<<6)
#define DT_EE_FILESYSTEM_DIR_ATTR_DATA_VALID				(1<<7)
*/
#define DT_EE_FILESYSTEM_DIR_ATTR_SUBDIR_VALID				5
#define DT_EE_FILESYSTEM_DIR_ATTR_READ_ONLY					6
#define DT_EE_FILESYSTEM_DIR_ATTR_DATA_VALID				7

// ------------------------------------
// Filesystem Commands
#define DT_EE_FILESYSTEM_CMD_READ							0x01
#define DT_EE_FILESYSTEM_CMD_WRITE							0x02
#define DT_EE_FILESYSTEM_CMD_GET_DIR_ENTRIES				0x03

// ------------------------------------
// Filesystem Commands Option flags
#define DT_EE_FS_FLAG_CREATE_DIR_IF_NOT_EXIST				0x01


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define LED_BLINK_SHORT										10		// 10 ms to blink short
