//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	ethernet_sample.c
//	project: ethernet_sample
//
//
//	(c) DEDITEC GmbH, 2009-2017
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
//
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "../../../delib-sources/delib/library/delib/delib.h"

int main()
{
	unsigned long i;
	unsigned long handle;
	unsigned long ret;
	DAPI_OPENMODULEEX_STRUCT open_buffer;
	
	strcpy((char*) open_buffer.address, "192.168.1.21");							// hostname
	open_buffer.timeout = 5000;													// 5000 msec
	open_buffer.portno = 9912;													// using default port
	
	#ifdef ENABLE_TCP_ENCRYPTION
		open_buffer.encryption_type = DAPI_OPEN_MODULE_ENCRYPTION_TYPE_ADMIN;	// encrypted communication with admin privileges
		strcpy((char*) open_buffer.encryption_password, "myPassword");			// password for encrypted communication
	#else
		open_buffer.encryption_type = DAPI_OPEN_MODULE_ENCRYPTION_TYPE_NONE;	
	#endif

	handle = DapiOpenModuleEx(ETHERNET_MODULE, 0, (unsigned char*) &open_buffer, DAPI_OPEN_MODULE_OPTION_USE_EXBUFFER);
	
	if(handle == 0)
	{
		printf("Handle = 0x%lx\n", handle);
		return 0;
	}

	for(i=0; i!=4; ++i)
	{
		printf("Durchlauf = %ld\n", i);
		
		DapiDOSet8(handle, 0, 0xff);
		
		usleep(1000 * 500);		 // 500 msec sleep
		
		DapiDOSet8(handle, 0, 0);
		
		usleep(1000 * 500);		 // 500 msec sleep
		
		ret = DapiDIGet8(handle, 0);
		printf("DI0-7 = 0x%lx\n", ret);
		
		usleep(1000 * 500);		 // 500 msec sleep
	}

	printf("ENDE\n");
	
	DapiCloseModule(handle);
}
